//+------------------------------------------------------------------+
//|                                                Order Closing.mq4 |
//|              harfa37 Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "harfa37 Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//---- input parameters
extern int       Ticket=0;
extern int       Closing_Hour=0;
extern int       Closing_Minute=0;
extern int       Slippage=3;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
   string text;
//----
   ObjectCreate("text1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("text1", "INIT...", 9, "Arial", Pink);
   ObjectSet("text1", OBJPROP_CORNER, 0);
   ObjectSet("text1", OBJPROP_XDISTANCE, 3);
   ObjectSet("text1", OBJPROP_YDISTANCE, 13);
   text=TimeToStr(StrToTime(StringConcatenate(Closing_Hour,":",Closing_Minute)),TIME_MINUTES);
   text=StringConcatenate("Order #",Ticket," is going to be closed at ",text);
   ObjectSetText("text1",text, 9, "Arial", Pink);
//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("text1");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   string text;  
//----
   if (Ticket!=0 && Closing_Hour==Hour() && Closing_Minute==Minute())
   {
      OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES);
      if (OrderType()==OP_BUY) OrderClose(Ticket,OrderLots(),Bid,Slippage,CLR_NONE);
      else OrderClose(Ticket,OrderLots(),Ask,Slippage,CLR_NONE);
      text=StringConcatenate("Order #",Ticket," was closed at ",Closing_Hour,":",Closing_Minute);
      ObjectSetText("text1",text, 9, "Arial", Pink);
   }
//----
   return(0);
}
//+------------------------------------------------------------------+